//+------------------------------------------------------------------+
//|                                                  JMA_MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, scorpion."
#property  link      "http://www.fxfisherman.com/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Gray
#property  indicator_color2  Silver
#property  indicator_color3  Red
#property  indicator_width2  2
//---- indicator parameters
extern int FastJMA=12;
extern int SlowJMA=26;
extern int SignalSMA=9;
extern int FastJMAPhrase=0;
extern int SlowJMAPhrase=0;
//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
      SetIndexBuffer(0,ind_buffer3);
      SetIndexBuffer(1,ind_buffer1);
      SetIndexBuffer(2,ind_buffer2);
   IndicatorShortName("JMA MACD("+FastJMA+","+SlowJMA+","+SignalSMA+")");
   SetIndexLabel(0,"JMAMACD");
   SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)
      ind_buffer1[i]= iCustom(NULL,0,"JMA",FastJMA,FastJMAPhrase,0,i) - iCustom(NULL,0,"JMA",SlowJMA,SlowJMAPhrase,0,i);
      //ind_buffer1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd buffer
   for(i=0; i<limit; i++)
   {
      ind_buffer2[i]=iMAOnArray(ind_buffer1,Bars,SignalSMA,0,MODE_SMA,i);
      ind_buffer3[i]=ind_buffer1[i]-ind_buffer2[i];
   }      
   return(0);
  }